from string import strip
'''
  #############################################################################
  #
  #     This Cplant(TM) source code is the property of Sandia National
  #     Laboratories.
  #
  #     This Cplant(TM) source code is copyrighted by Sandia National
  #     Laboratories.
  #
  #     The redistribution of this Cplant(TM) source code is subject to the
  #     terms of the GNU Lesser General Public License
  #     (see cit/LGPL or http://www.gnu.org/licenses/lgpl.html)
  #
  #     Cplant(TM) Copyright 1998, 1999, 2000, 2001, 2002 Sandia Corporation.
  #     Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
  #     license for use of this work by or on behalf of the US Government.
  #     Export of this program may require a license from the United States
  #     Government.
  #
  #############################################################################
'''

class testdata:
	def __init__(self,name):
		self.name = name
		self.minPctMatch = 0.0
		self.maxPctMatch = 100.0
		self.pctMatched = 0.0
		self.status = ''	# PASS/FAIL
		self.numReps =0		# how many iters we're supposed to run
		self.nIterExec =0	# how many iters we ran
		self.nMatch =0		# how many iters passed
		self.mismatches =[]	# failure info (fiter, titer, [(bufTag, bufType, expected, actual)]
		self.failDeps = 0	# Dependency Failure? (0=no, 1=yes)
		self.type = ''		# sssTest, shellTest, etc
		self.depXML = ''

	def update(self,**argd):
		for key in argd.keys():
			self.__dict__[key]=argd[key]

	def Print(self): 
		print 40*'-'
		for k in self.__dict__:
			print "%-10s"%(k), "::", `self.__dict__[k]`

class filedata:

	def __init__(self):
		self.fname  =""
		self.title =""
		self.authname  =""
		self.authphon  =""
		self.authmail  =""
		self.contname  =""
		self.contphon  =""
		self.contmail  =""
		self.desc      =""
		self.testnames =[]
		self.testdata  ={}
	
	def addTest(self, name):
		if name not in self.testnames:
			self.testnames.append(name)
			self.testdata[name] = testdata(name)

	def update(self, **argd):
		for argkey in argd.keys():
			self.__dict__[argkey] = argd[argkey]

	def updateTest(self, name, **argd):
		''' '''
		if name in self.testdata:
			test = self.testdata[name]
			for argkey in argd.keys():
				test.__dict__[argkey] = argd[argkey]

	def addPerson(self, tag, name, phone, email):
		if tag == 'author':
			self.authname = strip(name)
			self.authphon = strip(phone)
			self.authmail = strip(email)
		elif tag == 'contact':
			self.contname = strip(name)
			self.contphon = strip(phone)
			self.contmail = strip(email)

	def SummaryLine(self):
		nPass = 0.0
		nTest = float(len(self.testdata))
		for i in self.testdata.keys():
			if self.testdata[i].status=='PASS': nPass += 1
		sl = '%s;%s;%4.1f;\n'%(self.fname,self.title,nPass/nTest*100.0)
		return sl

	def genXMLsummary(self):
#		print self.__dict__
		str = ''
		str += '<?xml version="1.0" encoding="utf-8" ?>\n'
		str += '<resultFile>\n'
		str += '  <resultFileData name="%s" \n'%(self.title)
		str += '      exec_date="%s"  exec_time="%s"\n'%('date','time')
		str += '      auth_name="%s"  auth_phon="%s"\n'%(self.authname, self.authphon)
		str += '      cont_name="%s"  cont_phon="%s">\n'%(self.contname, self.contphon)
		str += '    <description>%s</description>\n'%(self.desc)
		str += '  </resultFileData>\n'
		for k in self.testdata.keys():
			t = self.testdata[k]
#			print t.__dict__
			if t.status==None: t.status='DNE'
			str += '\n  <resultEntry name="%s"\n'%(t.name)
			str += '        pctMatched="%d"  status="%s"\n'%(t.pctMatched,t.status)
			str += '        minPctExpect="%s" maxPctExpect="%s"\n'%(t.minPctMatch,t.maxPctMatch)
			str += '        nItersActual="%s" nItersExpect="%s">\n'%(t.nIterExec,t.numReps)
			for mis in t.mismatches:
#				print "--->",mis
				str += '    <iterFail number="%s">\n'%(mis[0])
#				str += '        <actual="%s">%s</actual>\n'%('foobar',mis[2])
				str += '    </iterFail>\n'
			str += t.depXML
			str += '  </resultEntry>\n'

		str += '\n</resultFile>\n'
		return str

	def Print(self):
		for k in self.__dict__:
			if k not in ['testdata']:
				print "%-10s"%(k), "::", `self.__dict__[k]`
		for k in self.testnames:
			self.testdata[k].Print()



# EOF
